/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: dve68k.h 817 2008-03-18 01:33:12Z hiro $
 */

/*
 *		DVE-68K/40 CPU{[h̃n[hEFA̒`
 */

#ifndef TOPPERS_DVE68K_H
#define TOPPERS_DVE68K_H

#include <sil.h>

/*
 *  ݔԍiintnoj̒`
 */
#define TINTNO_ACF		1U			/* ACFAIL */
#define TINTNO_ABT		2U			/* A{[g */
#define TINTNO_SF		3U			/* SYSFAIL */
#define TINTNO_BER		4U			/* oXG[ */
#define TINTNO_IAK		5U			/* IAK */
#define TINTNO_SRQ		6U			/* SRQ */
#define TINTNO_SAK		7U			/* SAK */
#define TINTNO_GP7		9U			/* GP7 */
#define TINTNO_DMA		10U			/* DMA */
#define TINTNO_TT1		11U			/* ^C}1 */
#define TINTNO_TT0		12U			/* ^C}0 */
#define TINTNO_GP3		13U			/* tbV */
#define TINTNO_GP2		14U			/* SCSI */
#define TINTNO_GP1		15U			/* Ethernet */
#define TINTNO_GP0		16U			/* VAI/O */
#define TINTNO_SWI7		17U			/* \tgEFA7 */
#define TINTNO_SWI6		18U			/* \tgEFA6 */
#define TINTNO_SWI5		19U			/* \tgEFA5 */
#define TINTNO_SWI4		20U			/* \tgEFA4 */
#define TINTNO_SWI3		21U			/* \tgEFA3 */
#define TINTNO_SWI2		22U			/* \tgEFA2 */
#define TINTNO_SWI1		23U			/* \tgEFA1 */
#define TINTNO_SWI0		24U			/* \tgEFA0 */
#define TINTNO_VM7		25U			/* VME7 */
#define TINTNO_VM6		26U			/* VME6 */
#define TINTNO_VM5		27U			/* VME5 */
#define TINTNO_VM4		28U			/* VME4 */
#define TINTNO_VM3		29U			/* VME3 */
#define TINTNO_VM2		30U			/* VME2 */
#define TINTNO_VM1		31U			/* VME1 */

/*
 *  ݃xNg̐ݒl̒`
 */
#define TVEC_G0I		0x40U		/* O[v0݃xNg */
#define TVEC_G1I		0x48U		/* O[v1݃xNg */
#define TVEC_SWI		0x50U		/* \tgEFA݃xNg */
#define TVEC_SPRI		0x40U		/* XvAX݃xNg */

/*
 *  ݃nhԍiinhnoj̒`
 */
#define TINHNO_ACF		0x47U		/* ACFAIL */
#define TINHNO_ABT		0x46U		/* A{[g */
#define TINHNO_SF		0x45U		/* SYSFAIL */
#define TINHNO_BER		0x44U		/* oXG[ */
#define TINHNO_IAK		0x43U		/* IAK */
#define TINHNO_SRQ		0x42U		/* SRQ */
#define TINHNO_SAK		0x41U		/* SAK */
#define TINHNO_GP7		0x4fU		/* GP7 */
#define TINHNO_DMA		0x4eU		/* DMA */
#define TINHNO_TT1		0x4dU		/* ^C}1 */
#define TINHNO_TT0		0x4cU		/* ^C}0 */
#define TINHNO_GP3		0x4bU		/* tbV */
#define TINHNO_GP2		0x4aU		/* SCSI */
#define TINHNO_GP1		0x49U		/* Ethernet */
#define TINHNO_GP0		0x48U		/* VAI/O */
#define TINHNO_SWI7		0x57U		/* \tgEFA7 */
#define TINHNO_SWI6		0x56U		/* \tgEFA6 */
#define TINHNO_SWI5		0x55U		/* \tgEFA5 */
#define TINHNO_SWI4		0x54U		/* \tgEFA4 */
#define TINHNO_SWI3		0x53U		/* \tgEFA3 */
#define TINHNO_SWI2		0x52U		/* \tgEFA2 */
#define TINHNO_SWI1		0x51U		/* \tgEFA1 */
#define TINHNO_SWI0		0x50U		/* \tgEFA0 */
#define TINHNO_SPRI		0x40U		/* XvAX */

/*
 *  CPU{[h̃WX^
 */
#define TADR_BOARD_REG0		0xfff48000
#define TADR_BOARD_REG1		0xfff48004
#define TADR_BOARD_REG2		0xfff48008

/*
 *  DGA-001̃WX^̃AhX
 */
#define TADR_DGA_CSR0		0xfff44000
#define TADR_DGA_CSR1		0xfff44004
#define TADR_DGA_CSR3		0xfff4400c
#define TADR_DGA_CSR4		0xfff44010
#define TADR_DGA_CSR5		0xfff44014
#define TADR_DGA_CSR12		0xfff44030
#define TADR_DGA_CSR13		0xfff44034
#define TADR_DGA_CSR14		0xfff44038
#define TADR_DGA_CSR15		0xfff4403c
#define TADR_DGA_CSR18		0xfff44048
#define TADR_DGA_CSR19		0xfff4404c
#define TADR_DGA_CSR20		0xfff44050
#define TADR_DGA_CSR21		0xfff44054
#define TADR_DGA_CSR23		0xfff4405c
#define TADR_DGA_CSR24		0xfff44060
#define TADR_DGA_IFR0		0xfff44070
#define TADR_DGA_IFR3		0xfff4407c

/*
 *  DGA-001̊ݗDxݒ̂߂̒`
 */
#define TIRQ_NMI		(-7)		/* m}XJu */
#define TIRQ_LEVEL6		(-6)		/* ݃x6 */
#define TIRQ_LEVEL5		(-5)		/* ݃x5 */
#define TIRQ_LEVEL4		(-4)		/* ݃x4 */
#define TIRQ_LEVEL3		(-3)		/* ݃x3 */
#define TIRQ_LEVEL2		(-2)		/* ݃x2 */
#define TIRQ_LEVEL1		(-1)		/* ݃x1 */

/*
 *  DGAւ̃ANZX֐
 */
#define dga_rew_reg(addr)			sil_rew_mem(addr)
#define dga_wrw_reg(addr, val)		sil_wrw_mem(addr, val)

/*
 *  DGÃWX^ւ̃ANZX֐
 */
#ifndef TOPPERS_MACRO_ONLY

Inline uint32_t
dga_read(void *addr)
{
	return((uint32_t) dga_rew_reg(addr));
}

Inline void
dga_write(void *addr, uint32_t val)
{
	dga_wrw_reg(addr, val);
}

Inline void
dga_bit_or(void *addr, uint32_t bitpat)
{
	dga_write(addr, dga_read(addr) | bitpat);
}

Inline void
dga_bit_and(void *addr, uint32_t bitpat)
{
	dga_write(addr, dga_read(addr) & bitpat);
}

Inline void
dga_set_ilv(void *addr, uint_t shift, uint_t level)
{
	dga_write(addr, (dga_read(addr) & ~(0x07 << shift)) | (level << shift));
} 

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  PD72001iMPSCj̃WX^̃AhX
 */
#define TADR_UPD72001_DATAA		0xfff45003U
#define TADR_UPD72001_CTRLA		0xfff45007U
#define TADR_UPD72001_DATAB		0xfff4500bU
#define TADR_UPD72001_CTRLB		0xfff4500fU

/*
 *  PD72001ւ̃ANZX֐
 */
#define upd72001_reb_reg(addr)			sil_reb_mem(addr)
#define upd72001_wrb_reg(addr, val)		sil_wrb_mem(addr, val)

/*
 *  Jˑ̏
 */
#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_GDB_STUB				/* GDBX^u */

Inline void
dve68k_exit(void)
{
	Asm("trap #2");
}

Inline void
dve68k_putc(char_t c)
{
	Asm("move.l %0, %%d1; trap #3"
	  : /* no output */
	  : "g"(c)
	  : "d0", "d1", "d2", "d6", "d7");
}

#else /* TOPPERS_GDB_STUB */		/* ̑̊J */

extern void		dve68k_exit(void) NoReturn;
extern void		dve68k_putc(char_t c);

#endif /* TOPPERS_GDB_STUB */
#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_DVE68K_H */
